#gets executed every game tick



#water balloons
execute at @e[type=minecraft:experience_bottle] run particle minecraft:splash ~ ~ ~ 0.05 0.05 0.05 0.1 1 force
execute as @e[type=minecraft:experience_orb,limit=1] run data merge entity @s {Count:999}
execute at @e[type=minecraft:experience_orb] run summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water"], Age:5600}
kill @e[type=minecraft:experience_orb]


#shoot goop blobs
execute as @e[tag=goop_blob] at @s if block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=false] run kill @s
execute at @e[tag=pink_goop_blob] run particle minecraft:block{block_state:"minecraft:muddy_mangrove_roots"} ~ ~ ~ 0.05 0.05 0.05 0.1 1 normal
execute at @e[tag=toxic_goop_blob] run particle minecraft:block{block_state:"minecraft:coarse_dirt"} ~ ~ ~ 0.05 0.05 0.05 0.1 1 normal
scoreboard players add @e[tag=shoot_goop_blob,limit=15,sort=random] shoot_goop_blob_time 1
execute as @e[tag=shoot_pink_goop_blob,scores={shoot_goop_blob_time=40..}] at @s positioned ~ ~1.7 ~ run function ercerus:goop_cleanup/shot_pink_goop_blob
execute as @e[tag=shoot_toxic_goop_blob,scores={shoot_goop_blob_time=40..}] at @s positioned ~ ~1.7 ~ run function ercerus:goop_cleanup/shot_toxic_goop_blob
scoreboard players set @e[tag=shoot_goop_blob,scores={shoot_goop_blob_time=40..}] shoot_goop_blob_time 0
execute as @e[tag=pink_goop_blob,nbt={OnGround:1b}] at @s run function ercerus:goop_cleanup/pink_goop_blob_ground_impact
execute as @e[tag=toxic_goop_blob,nbt={OnGround:1b}] at @s run function ercerus:goop_cleanup/toxic_goop_blob_ground_impact


#goop blob life time, so they do not accumulate in non-entity processing chunks
scoreboard players add @e[tag=goop_blob] life_time 1
kill @e[tag=goop_blob,scores={life_time=200..}]


#toxic goop damage
execute as @a[gamemode=!spectator,gamemode=!creative,tag=!spread_toxic_goop] at @s anchored feet if block ~ ~-0.05 ~ #ercerus:toxic_goop run damage @s 1 minecraft:mob_attack


#remove arrows/goop projectiles which have hit the ground
execute as @e[type=minecraft:arrow] at @s if block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=false] run kill @s
execute at @e[type=minecraft:arrow,nbt={inGround:true}] run function ercerus:goop_cleanup/place_goop/pink_1x1
kill @e[type=minecraft:arrow,nbt={inGround:true}]


#goop ambient particles
#ambient pink and toxic goop particles
#spreadplayers commands cause ginormous amounts of server lag, if they can't find a position to spread to, as happens on the open ocean, which is why the "unless block ~ 60 ~ ercerus:water" is necassary
execute at @r unless block ~ 60 ~ #ercerus:block_always_contains_water unless block ~ 60 ~ #ercerus:block_can_contain_water[waterlogged=true] run summon minecraft:marker ~ ~ ~ {Tags:[goop_particle_marker]}
execute as @e[tag=goop_particle_marker] at @s run spreadplayers ~ ~ 12 12 false @s
execute at @e[tag=goop_particle_marker] run function ercerus:goop_cleanup/goop_particles
kill @e[tag=goop_particle_marker]
#goop bubbles
kill @e[tag=goop_bubble,scores={life_time=160..}]
#skulls above toxic goop
execute at @r unless block ~ 60 ~ #ercerus:block_always_contains_water unless block ~ 60 ~ #ercerus:block_can_contain_water[waterlogged=true] run summon minecraft:marker ~ ~ ~ {Tags:[toxic_goop_particle_marker]}
execute as @e[tag=toxic_goop_particle_marker] at @s run spreadplayers ~ ~ 8 8 false @s
execute at @e[tag=toxic_goop_particle_marker] if block ~ ~-0.05 ~ #ercerus:toxic_goop_no_carpets run particle minecraft:mycelium ~ ~0.1 ~ 0.2 0 0.2 0.02 1 normal
kill @e[tag=toxic_goop_particle_marker]
#cloudy goop particles (as cloudy goop patch is above the open ocean, a special case for its particle generator is necassary)
execute at @r if block ~ ~-1 ~ #ercerus:cloudy_goop run summon minecraft:marker ~ ~ ~ {Tags:[cloudy_goop_particle_marker]}
execute as @e[tag=cloudy_goop_particle_marker] at @s run spreadplayers ~ ~ 12 12 false @s
execute at @e[tag=cloudy_goop_particle_marker] run function ercerus:goop_cleanup/cloudy_goop_particles
kill @e[tag=cloudy_goop_particle_marker]

#spawn living goop blobs
#pink
#execute at @r unless block ~ 60 ~ #ercerus:block_always_contains_water unless block ~ 60 ~ #ercerus:block_can_contain_water[waterlogged=true] run summon minecraft:marker ~ ~ ~ {Tags:[living_pink_goop_marker]}
#execute as @e[tag=living_pink_goop_marker] at @s run spreadplayers ~ ~ 64 64 false @s
#execute at @e[tag=living_pink_goop_marker] if block ~ ~-0.05 ~ #ercerus:pink_goop_no_carpets run function ercerus:enemies/summon/pink_living_blob
#kill @e[tag=living_pink_goop_marker]


#particles around paradise blossoms
execute at @e[tag=paradise_blossom,tag=!blooming] run particle minecraft:large_smoke ~ ~ ~ 1.8 1.8 1.8 0.05 1 normal