#free inhabitants stuck in goop



#thank the player
tellraw @a[distance=..16] ["",{"text":"[","color":"gold"},{"text":"Island Inhabitant","color":"yellow"},{"text":"]","color":"gold"},{"text":" Oh, thanks for freeing me from this sticky goop!"}]


#free inhabitants based on their color
execute if entity @s[tag=yellow] positioned ~ ~0.01 ~ run function ercerus:npc/inhabitant/yellow/default
execute if entity @s[tag=gray] positioned ~ ~0.01 ~ run function ercerus:npc/inhabitant/gray/default
execute if entity @s[tag=brown] positioned ~ ~0.01 ~ run function ercerus:npc/inhabitant/brown/default
execute if entity @s[tag=white] positioned ~ ~0.01 ~ run function ercerus:npc/inhabitant/white/default
execute if entity @s[tag=black] positioned ~ ~0.01 ~ run function ercerus:npc/inhabitant/black/default


#summon a default inhabitant, in case they do not have a color associated with them
execute positioned ~ ~0.01 ~ unless entity @e[tag=inhabitant,tag=!stuck_in_goop,distance=0] run function ercerus:npc/inhabitant/yellow/default


#tag rescued inhabitants
execute positioned ~ ~0.01 ~ run tag @e[tag=inhabitant,distance=0] add recued_from_goop
execute positioned ~ ~0.01 ~ run team join no_attacking @e[tag=inhabitant,distance=0]


#audio-visual cues
playsound minecraft:ambient.goop_impact ambient @a ~ ~ ~ 1 1.5
playsound minecraft:item.bucket.empty ambient @a ~ ~ ~ 1 1 0
particle minecraft:heart ~ ~1.5 ~ 0.5 0.5 0.5 0 5 normal
execute if entity @s[tag=stuck_in_pink_goop] run particle minecraft:block{block_state:"minecraft:muddy_mangrove_roots"} ~ ~1 ~ 0.3 0.5 0.3 0.1 100 normal
execute if entity @s[tag=stuck_in_toxic_goop] run particle minecraft:block{block_state:"minecraft:coarse_dirt"} ~ ~1 ~ 0.3 0.5 0.3 0.1 100 normal


#grant the advancement
advancement grant @a only ercerus:help_me


#remove the inhabitant, who is stuck in goop
kill @s