#gets executed every game tick



#audio-visual cues
execute at @e[tag=spawner,type=!player] positioned ~ ~1 ~ run particle minecraft:poof ~ ~ ~ 0.5 0 0.5 0 1 normal
scoreboard players add @e[tag=spawner,tag=!silent,sort=random,limit=1] sound_time 1
execute at @e[tag=spawner,scores={sound_time=100}] run playsound minecraft:entity.spawner.ambient hostile @a ~ ~ ~ 0.4 1 0
scoreboard players set @e[tag=spawner,scores={sound_time=100..}] sound_time 0


#increase spawn timer if conditions are met
execute as @e[tag=spawner] at @s store result score @s count if entity @e[tag=enemy,distance=..48]
execute as @e[tag=spawner,tag=!inactive] at @s if entity @p[distance=..48,gamemode=!creative,gamemode=!spectator] if score @s count matches ..16 run function ercerus:spawner/increase_spawner_time


#summon monsters
execute as @e[tag=pink_spawner,scores={spawner_time=30..}] at @s positioned ~0.5 ~2 ~0.5 run function ercerus:spawner/spawn_pink_spawner_enemy
execute as @e[tag=toxic_spawner,scores={spawner_time=30..}] at @s positioned ~0.5 ~2 ~0.5 run function ercerus:spawner/spawn_toxic_spawner_enemy


#update the health display of the closest spawner for every player
execute at @a[tag=red] run function ercerus:spawner/health_bars/red
execute at @a[tag=blue] run function ercerus:spawner/health_bars/blue
execute at @a[tag=gold] run function ercerus:spawner/health_bars/gold
execute at @a[tag=green] run function ercerus:spawner/health_bars/green
execute at @a[tag=light_purple] run function ercerus:spawner/health_bars/light_purple
execute at @a[tag=white] run function ercerus:spawner/health_bars/white
execute at @a[tag=aqua] run function ercerus:spawner/health_bars/aqua
execute at @a[tag=yellow] run function ercerus:spawner/health_bars/yellow


#update the health display of the closest spawner for every player
execute at @a[tag=red] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:red_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=blue] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:blue_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=gold] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:gold_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=green] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:green_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=light_purple] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:light_purple_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=white] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:white_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=aqua] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:aqua_spawner_health value run scoreboard players get @s spawner_health
execute at @a[tag=yellow] as @e[tag=spawner,limit=1,sort=nearest,type=!player] store result bossbar minecraft:yellow_spawner_health value run scoreboard players get @s spawner_health

execute as @a[tag=red] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:red_spawner_health players @s
execute as @a[tag=blue] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:blue_spawner_health players @s
execute as @a[tag=gold] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:gold_spawner_health players @s
execute as @a[tag=green] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:green_spawner_health players @s
execute as @a[tag=light_purple] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:light_purple_spawner_health players @s
execute as @a[tag=white] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:white_spawner_health players @s
execute as @a[tag=aqua] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:aqua_spawner_health players @s
execute as @a[tag=yellow] at @s if entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:yellow_spawner_health players @s

execute as @a[tag=red] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:red_spawner_health players
execute as @a[tag=blue] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:blue_spawner_health players
execute as @a[tag=gold] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:gold_spawner_health players
execute as @a[tag=green] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:green_spawner_health players
execute as @a[tag=light_purple] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:light_purple_spawner_health players
execute as @a[tag=white] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:white_spawner_health players
execute as @a[tag=aqua] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:aqua_spawner_health players
execute as @a[tag=yellow] at @s unless entity @e[tag=spawner,distance=..20,type=!player] run bossbar set minecraft:yellow_spawner_health players


#damage and death
execute at @e[tag=water_gun_water,tag=cause_water_spaltter_explosion] if entity @e[tag=spawner,tag=!invulnerable,distance=..1.9,type=!player] run function ercerus:water_gun/water_splatter_explosion
execute at @e[tag=water_gun_water,tag=!goop_gun_blob,tag=!cause_water_spaltter_explosion] as @e[tag=spawner,tag=!invulnerable,distance=..1.9,type=!player] run function ercerus:spawner/damage_spawner
execute at @e[tag=spawner,type=!player] run kill @e[tag=water_gun_water,distance=..1.9]
execute as @e[tag=spawner,scores={spawner_health=..0},type=!player] at @s run function ercerus:spawner/kill_spawner


#reset
scoreboard players set @e[tag=spawner,tag=successful_spawn,scores={spawner_time=30..}] spawner_time 0
tag @e[tag=spawner,tag=successful_spawn] remove successful_spawn