#shoots the player into the sky by using the rocket thruster



#right click
tag @s add blast_upwards
execute if block ~ ~ ~ #ercerus:block_always_contains_water run tag @s remove blast_upwards
execute if block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=true] run tag @s remove blast_upwards
execute if block ~ ~1.7 ~ #ercerus:block_always_contains_water run tag @s remove blast_upwards
execute if block ~ ~1.7 ~ #ercerus:block_can_contain_water[waterlogged=true] run tag @s remove blast_upwards 
execute as @s[tag=blast_upwards,tag=!rocket_thruster_disabled,scores={sneak=0}] run function ercerus:water_gun/blast_upwards
tag @s remove blast_upwards


#sadly fails underwater due to the way Minecraft works, so add a failure effect
execute if entity @s[tag=!rocket_thruster_disabled] if block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=false] if block ~ ~1.7 ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~1.7 ~ #ercerus:block_can_contain_water[waterlogged=false] run particle minecraft:bubble ~ ~1 ~ 0.5 0.5 0.5 0.1 80 normal
execute if entity @s[tag=!rocket_thruster_disabled] if block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=false] run playsound ambient.glug ambient @a ~ ~ ~ 1 1.5 0


#shoot out a circular water burst when the player is sneaking
execute if entity @s[tag=!rocket_thruster_disabled,scores={sneak=1..}] run function ercerus:water_gun/circular_water_burst
execute if entity @s[tag=!rocket_thruster_disabled,scores={sneak=1..}] run particle minecraft:cloud ~ ~ ~ 0.1 0.1 0.1 0.3 150 normal
execute if entity @s[tag=!rocket_thruster_disabled,tag=!goop_gun,scores={sneak=1..}] run particle minecraft:splash ~ ~ ~ 1 0.1 1 0.1 100 normal


#reduce the water level of the gun after usage
execute unless entity @s[tag=infinite_water] unless entity @s[tag=rocket_thruster_disabled] if entity @s[tag=!2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 20
execute unless entity @s[tag=infinite_water] unless entity @s[tag=rocket_thruster_disabled] if entity @s[tag=2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 10


#disabled rocket thruster
execute if entity @s[tag=rocket_thruster_disabled] run playsound minecraft:block.bamboo.step ambient @a ~ ~ ~ 1 1
execute if entity @s[tag=rocket_thruster_disabled] run particle minecraft:smoke ~ ~1 ~ 0.75 0.5 0.75 0 7


#reset
tag @e[type=minecraft:item,tag=water_gun_water] add motion_has_been_applied