#sprays water from the water gun



#right click
execute if entity @s[tag=!water_gun_disabled] unless block ~ ~1.7 ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~1.7 ~ #ercerus:block_can_contain_water[waterlogged=true] run playsound minecraft:weather.rain ambient @a ~ ~ ~ 0.5 1.8 0
execute if entity @s[tag=!water_gun_disabled] rotated as @s in minecraft:overworld positioned 0 0 0 align xyz run summon minecraft:armor_stand ^ ^ ^1 {Invulnerable:1b,NoGravity:1b,Tags:["aim"]}
execute if entity @s[tag=!water_gun_disabled,tag=!goop_gun] anchored eyes run summon minecraft:item ^ ^ ^1 {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water"], Age:5600}
execute if entity @s[tag=!water_gun_disabled,tag=goop_gun] anchored eyes run summon minecraft:item ^ ^ ^1 {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water","goop_gun_blob"], Age:5600}
execute if entity @s[tag=!water_gun_disabled] anchored eyes positioned ^ ^ ^1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionX run data get entity @e[tag=aim,limit=1] Pos[0] 750
execute if entity @s[tag=!water_gun_disabled] anchored eyes positioned ^ ^ ^1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionY run data get entity @e[tag=aim,limit=1] Pos[1] 750
execute if entity @s[tag=!water_gun_disabled] anchored eyes positioned ^ ^ ^1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionZ run data get entity @e[tag=aim,limit=1] Pos[2] 750
kill @e[tag=aim]
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[0] double 0.0015 run scoreboard players get @s MotionX
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[1] double 0.0015 run scoreboard players get @s MotionY
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[2] double 0.0015 run scoreboard players get @s MotionZ
tag @e[type=minecraft:item,tag=water_gun_water] add motion_has_been_applied


#shoot out a shotgun like burst of water when the player is sneaking
execute if entity @s[tag=!water_gun_disabled,scores={sneak=1..}] run function ercerus:water_gun/shotgun_water_burst


#reduce the water level of the gun after usage
execute unless entity @s[tag=infinite_water] unless entity @s[tag=water_gun_disabled] if entity @s[tag=!2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 2
execute unless entity @s[tag=infinite_water] unless entity @s[tag=water_gun_disabled] if entity @s[tag=2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 1


#disabled water gun
execute if entity @s[tag=water_gun_disabled] run playsound minecraft:block.bamboo.step ambient @a ~ ~ ~ 1 1
execute if entity @s[tag=water_gun_disabled] run particle minecraft:smoke ~ ~1 ~ 0.75 0.5 0.75 0 7
