#gets executed every game tick



#turn dropped collectibles in free floating collectibles
execute as @e[type=item,nbt={Item:{id:"minecraft:shulker_shell",count:1}}] at @s run function ercerus:collectibles/summon_granchio_emblem
kill @e[type=item,nbt={Item:{id:"minecraft:shulker_shell",count:1}}]


#prevent players from losing emblems by dropping more than one at the same time
execute as @e[type=item,nbt={Item:{id:"minecraft:shulker_shell"}}] run data merge entity @s {PickupDelay:0s}
tp @e[type=item,nbt={Item:{id:"minecraft:shulker_shell"}}] @p[gamemode=!spectator]


#particles around the granchio emblems
execute at @e[tag=granchio_emblem] run particle minecraft:glow ~ ~0.85 ~ 1 1 1 0 1 normal
execute at @e[tag=granchio_emblem] run particle minecraft:wax_off ~ ~0.85 ~ 1 1 1 0 1 force


#rotate the collectibles
execute as @e[tag=granchio_emblem] at @s run tp @s ~ ~ ~ ~2 ~


#ambient sounds
execute at @e[tag=granchio_emblem,scores={sound_time=60}] run playsound minecraft:entity.experience_orb.pickup ambient @a ~ ~ ~ 1.5 0.5 0
scoreboard players set @e[tag=granchio_emblem,scores={sound_time=60..}] sound_time 0


#hint art
execute at @e[tag=hint_art_location] run scoreboard players add @a[distance=..1] hint_art 1
execute as @a if entity @s[scores={hint_art=60..}] at @s run function ercerus:collectibles/hint_art_location_found
scoreboard players set @a[scores={hint_art=60..}] hint_art 0
execute as @a[gamemode=!spectator] at @s unless entity @e[tag=hint_art_location,distance=..1] run scoreboard players set @s hint_art 0


#pick up the granchio emblems
execute as @a[gamemode=!spectator] at @s as @e[tag=granchio_emblem,distance=..1.2] run function ercerus:collectibles/pick_up_granchio_emblem


#collectible tracker
#the tool gets triggered inside the water guns datapack, as the right click detector is reset in this datapack