#gets executed every game tick



#audio-visual cues of the enemies
scoreboard players add @e[tag=goop_monster_sounds,tag=!silent,sort=random,limit=1] sound_time 1
execute at @e[tag=goop_monster_sounds,scores={sound_time=60}] run playsound minecraft:entity.goop_monster.ambient hostile @a ~ ~ ~ 0.4 1 0
scoreboard players set @e[tag=goop_monster_sounds,scores={sound_time=60..}] sound_time 0
execute at @e[tag=spread_pink_goop,tag=gooper] run particle minecraft:block{block_state:"minecraft:muddy_mangrove_roots"} ~ ~-0.1 ~ 0.1 0.0 0.1 0.05 2 normal
execute at @e[tag=spread_pink_goop,tag=glider] run particle minecraft:block{block_state:"minecraft:muddy_mangrove_roots"} ~ ~ ~ 0.1 0.0 0.1 0.05 1 normal
execute at @e[tag=spread_toxic_goop,limit=1,sort=random,type=!player,tag=!toxic_poker] run particle minecraft:mycelium ~ ~1.2 ~ 0.4 0.5 0.4 0 1 normal
execute at @e[tag=spread_toxic_goop,limit=1,sort=random,type=!player,tag=toxic_poker] run particle minecraft:mycelium ~ ~0.5 ~ 0.4 0.5 0.4 0 1 normal


#enemies make a mess by spreading goop
execute at @e[tag=spread_pink_goop,limit=10,sort=random] unless block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=true] run function ercerus:goop_cleanup/place_goop/pink_1x1
execute at @e[tag=spread_toxic_goop,limit=10,sort=random] unless block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=true] run function ercerus:goop_cleanup/place_goop/toxic_1x1
execute as @e[tag=enemy] at @s if block ~ ~ ~ #ercerus:all_potentially_water_containing_blocks unless block ~ ~ ~ #ercerus:block_can_contain_water[waterlogged=false] run kill @s


#toxic enemies attack by summoning toxic goop puddles to force players to move out of the water
scoreboard players add @e[tag=spread_toxic_goop,type=!player] goop_puddle_time 3
scoreboard players add @e[tag=spread_toxic_goop,sort=random,limit=1,type=!player] goop_puddle_time 1
execute as @e[tag=spread_toxic_goop,scores={goop_puddle_time=200..}] at @s if entity @p[gamemode=!creative,gamemode=!spectator,distance=..10] run function ercerus:enemies/attack_with_toxic_goop_puddle
scoreboard players set @e[tag=spread_toxic_goop,scores={goop_puddle_time=200..}] goop_puddle_time 0


#toxic goop puddle behaviour
execute as @a at @s if entity @e[tag=toxic_goop_puddle,distance=..1.8] run damage @s 1 minecraft:mob_attack
scoreboard players add @e[tag=toxic_goop_puddle] goop_puddle_time 1
execute as @e[tag=toxic_goop_puddle,scores={goop_puddle_time=20}] run data modify entity @s item.components.minecraft:custom_model_data set value 6269013
execute as @e[tag=toxic_goop_puddle,scores={goop_puddle_time=40}] run data modify entity @s item.components.minecraft:custom_model_data set value 6269014
execute as @e[tag=toxic_goop_puddle,scores={goop_puddle_time=60..}] at @s run function ercerus:enemies/kill_toxic_goop_puddle


#elder guardians steal some water
execute as @a[nbt={active_effects:[{id:"minecraft:mining_fatigue"}]}] at @s run function ercerus:water_gun/steal_water/50
effect clear @a minecraft:mining_fatigue