#start the map



#change the music
execute as @a[tag=!plays_the_map] run function ercerus:music/change_music
tag @a[tag=!plays_the_map] add clean_the_island_music


#remove all the respawn points inside the tutorial area
execute positioned 4 -44 328 run kill @e[tag=dynamic_respawn_point,distance=..4]
execute positioned 4 -44 296 run kill @e[tag=dynamic_respawn_point,distance=..4]
execute positioned 4 -44 275 run kill @e[tag=dynamic_respawn_point,distance=..4]
execute positioned 4 -44 200 run kill @e[tag=dynamic_respawn_point,distance=..4]


#really make sure that the ending can trigger. This should not be necassary and is here only to be really sure it works.
setblock -13 -6 115 minecraft:redstone_block
setblock -13 -6 118 minecraft:bedrock


#start the news once the player leaves the port
setblock -15 -1 115 minecraft:redstone_block


#start the ambient particles
setblock 4 -1 120 minecraft:bedrock


#no more water refills for the player, as the tuturial is over
setblock -15 -6 115 minecraft:bedrock


#remove unnecassary entities
execute positioned 4.5 -64.0 254.5 run kill @e[tag=goop_away_employee]
execute positioned 4.5 -64.0 254.5 run kill @e[tag=goop_away_supervisor]


#move all players to the start of the map
setworldspawn 4 65 167
tp @a[tag=!plays_the_map] 4.5 65.0 167.5 180 5
execute as @a[tag=!plays_the_map] at @s run function ercerus:reset/get_starter_items


#set the death counter to 0, so it shows up in the scoreboard later
scoreboard players set @a[tag=!plays_the_map] deaths 0


#refill the water gun
scoreboard players set @a[tag=!plays_the_map] water_level 200


#reset the playtime tracker
scoreboard players reset * playtime
setblock 15 -1 115 minecraft:redstone_block
setblock 15 -1 118 minecraft:bedrock


#show the amount of emblems to be found on the info scoreboard
setblock 15 -12 115 minecraft:redstone_block


#deactive the ability to choose hard or normal mode
setblock -9 -12 115 minecraft:bedrock
execute if block -4 4 116 minecraft:redstone_block unless block -4 5 116 minecraft:redstone_block run tellraw @a ["",{"text":"[","color":"gold"},{"text":"Adventure Map Helper","color":"light_purple"},{"text":"]","color":"gold"},{"text":" The map has been started in "},{"text":"Hard Mode","color":"gold"},{"text":"."}]
execute if block -4 5 116 minecraft:redstone_block run tellraw @a ["",{"text":"[","color":"gold"},{"text":"Adventure Map Helper","color":"light_purple"},{"text":"]","color":"gold"},{"text":" The map has been started in "},{"text":"Goopocalypse Mode","color":"red"},{"text":"."}]


#grant the starting advancement
advancement grant @a[tag=!plays_the_map] only ercerus:root


#indicate which version of the map is getting played
tellraw @a ["",{"text":"You are playing Version 1 of the map.","color":"gray"}]


#make sure that all currently online players will not be forced back to the start of the map, should a new player join after this function has been executed
tag @a add plays_the_map