#makes the player fast by using the turbo exhaust



#right click
execute if entity @s[tag=!turbo_exhaust_disabled] unless block ~ ~1.7 ~ #ercerus:block_always_contains_water unless block ~ ~1.7 ~ #ercerus:block_can_contain_water[waterlogged=true] run playsound minecraft:weather.rain ambient @a ~ ~ ~ 0.5 1.8 0
execute if entity @s[tag=!turbo_exhaust_disabled] anchored eyes run particle minecraft:cloud ^ ^ ^-1 0.2 0.2 0.2 0.1 10 normal
execute if entity @s[tag=!turbo_exhaust_disabled] rotated as @s in minecraft:overworld positioned 0 0 0 align xyz run summon minecraft:armor_stand ^ ^ ^-1 {Invulnerable:1b,NoGravity:1b,Tags:["aim"]}
execute if entity @s[tag=!turbo_exhaust_disabled,tag=!goop_gun] anchored eyes run summon minecraft:item ^ ^ ^-1 {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water"], Age:5600}
execute if entity @s[tag=!turbo_exhaust_disabled,tag=goop_gun] anchored eyes run summon minecraft:item ^ ^ ^-1 {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water","goop_gun_blob"], Age:5600}

execute if entity @s[tag=!turbo_exhaust_disabled] anchored eyes positioned ^ ^ ^-1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionX run data get entity @e[tag=aim,limit=1] Pos[0] 750
execute if entity @s[tag=!turbo_exhaust_disabled] anchored eyes positioned ^ ^ ^-1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionY run data get entity @e[tag=aim,limit=1] Pos[1] 750
execute if entity @s[tag=!turbo_exhaust_disabled] anchored eyes positioned ^ ^ ^-1 as @e[type=minecraft:item,distance=..1,tag=water_gun_water] in minecraft:overworld positioned 0 0 0 store result score @s MotionZ run data get entity @e[tag=aim,limit=1] Pos[2] 750
kill @e[tag=aim]
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[0] double 0.0015 run scoreboard players get @s MotionX
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[1] double 0.0015 run scoreboard players get @s MotionY
execute as @e[type=minecraft:item,tag=water_gun_water,tag=!motion_has_been_applied] store result entity @s Motion[2] double 0.0015 run scoreboard players get @s MotionZ


#speed and jump boost
execute if entity @s[tag=!turbo_exhaust_disabled,scores={turbo_exhaust_time=0}] run playsound minecraft:ambient.turbo_exhaust_start ambient @a ~ ~ ~ 1.0 1.0 0
execute if entity @s[tag=!turbo_exhaust_disabled,scores={turbo_exhaust_time=0}] anchored eyes run particle minecraft:cloud ^ ^ ^-1 0.1 0.1 0.1 0.3 100 normal
execute if entity @s[tag=!turbo_exhaust_disabled] run scoreboard players set @s turbo_exhaust_time 6
execute if entity @s[tag=!turbo_exhaust_disabled] run effect give @s minecraft:speed 1 8 true
execute if entity @s[tag=!turbo_exhaust_disabled] run effect give @s minecraft:jump_boost 1 0 true
execute if entity @s[tag=!turbo_exhaust_disabled] run effect give @s minecraft:dolphins_grace 1 0 true


#create puddle on the floor
execute if entity @s[nbt={OnGround:true}] run function ercerus:water_gun/summon/puddle/stage_1


#reduce the water level of the gun after usage
execute unless entity @s[tag=infinite_water] unless entity @s[tag=turbo_exhaust_disabled] if entity @s[tag=!2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 2
execute unless entity @s[tag=infinite_water] unless entity @s[tag=turbo_exhaust_disabled] if entity @s[tag=2x_water_capacity] run scoreboard players remove @s[gamemode=!creative] water_level 1


#reset
tag @e[type=minecraft:item,tag=water_gun_water] add motion_has_been_applied