#blasts out water in random directions



#audio-visual cues
particle minecraft:cloud ~ ~0.3 ~ 0.1 0 0.1 0.1 50 normal
playsound minecraft:ambient.water_burst ambient @a ~ ~ ~ 0.6 1.5 0


#summon water
summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water", "reduced_particles", "random_motion"], Age:5600, Motion:[0.5d, 0.3d, 0.1d]}
summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water", "reduced_particles", "random_motion"], Age:5600, Motion:[0.4d, 0.2d, -0.5d]}
summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water", "reduced_particles", "random_motion"], Age:5600, Motion:[-0.35d, 0.3d, -0.4d]}
summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water", "reduced_particles", "random_motion"], Age:5600, Motion:[-0.3d, 0.25d, 0.45d]}
summon minecraft:item ~ ~ ~ {Item: {id: "minecraft:slime_ball", Count: 1b}, PickupDelay: 32767, Tags: ["water_gun_water", "reduced_particles", "random_motion"], Age:5600, Motion:[-0.45d, 0.25d, 0.25d]}


#goop gun functionality, not ideal for multiplayer, but it is not easy to programm it well
execute if entity @s[tag=goop_gun_blob] run tag @e[tag=water_gun_water,distance=0] add goop_gun_blob


#randomize motion by shuffeling x, y & z motion values
execute as @e[tag=random_motion,limit=2,sort=random] run data modify entity @s Motion[0] set from entity @e[tag=random_motion,limit=1,sort=random] Motion[2]
execute as @e[tag=random_motion,limit=2,sort=random] run data modify entity @s Motion[1] set from entity @e[tag=random_motion,limit=1,sort=random] Motion[1]
execute as @e[tag=random_motion,limit=2,sort=random] run data modify entity @s Motion[2] set from entity @e[tag=random_motion,limit=1,sort=random] Motion[0]


#make sure existing water won't change its flight path mid flight
tag @e[tag=random_motion] add motion_has_been_applied
tag @e[tag=random_motion] add random_motion_has_been_applied
tag @e[tag=random_motion_has_been_applied] remove random_motion